<?php

namespace OrganismeExterneBundle\Controller;

use AppBundle\Entity\Organismeextern;
use AppBundle\Form\OrganismeExterneType;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\File\UploadedFile;
class OrganismeExterneController extends Controller
{

    /**
     * @return string
     */
    private function generateUniqueFileName()
    {
        // md5() reduces the similarity of the file names generated by
        // uniqid(), which is based on timestamps
        return md5(uniqid());
    }
    public function AjoutOrganismeExterneAction(Request $request){



        $organisme=new Organismeextern();
        $Form=$this->createForm(OrganismeExterneType::class,$organisme);
        $Form->handleRequest($request);
        if ($Form->isSubmitted() && $Form->isValid()) {


            // $file stores the uploaded PDF file
            /** @var UploadedFile $file */
            $file = $Form->get('image')->getData();

            $fileName = $this->generateUniqueFileName().'.'.$file->guessExtension();

            // Move the file to the directory where brochures are stored
            $PhotoDir=$this->getParameter('kernel.root_dir').'/../web/uploads';
            $file->move($PhotoDir,$fileName);

            // Update the 'brochure' property to store the PDF file name
            // instead of its contents
            $organisme->setImage($fileName);



            $em = $this->getDoctrine()->getManager();

            $em->persist($organisme);
            $em->flush();
            echo '<script type="text/javascript">' . 'alert("Ajout Avec Succes ");' . '</script>';
            return $this->redirectToRoute('_AfficherOrganismeExterne');
        }


        return $this->render('@OrganismeExterne/AjoutOrganismeExterne.html.twig',array('form'=>$Form->createView()));
    }


    public function AfficherOrganismeExterneAction()
    {

        $em=$this->getDoctrine()->getManager();
        $organisme=$em->getRepository('AppBundle:Organismeextern')->findAll();


        return $this->render('@OrganismeExterne/AfficherOrganismeExterne.html.twig',
            array(
                'v'=>$organisme
            ));
    }


    public function SupprimerOrganismeExterneAction( $idOrg){

        $em=$this->getDoctrine()->getManager();
        $org=$em->getRepository("AppBundle:Organismeextern")->find($idOrg);
        $em->remove($org);
        $em->flush();


        return $this->redirectToRoute('_AfficherOrganismeExterne');
    }


    public function ModifierOrganismeExterneAction(Request $request,$idOrg){



        $em=$this->getDoctrine()->getManager();
        $org=$em->getRepository("AppBundle:Organismeextern")->find($idOrg);
        $Form=$this->createForm(OrganismeExterneType::class,$org);
        $Form->handleRequest($request);
        if ($Form->isSubmitted() && $Form->isValid()) {
            // $file stores the uploaded PDF file
            /** @var UploadedFile $file */
            $file = $Form->get('image')->getData();

            $fileName = $this->generateUniqueFileName().'.'.$file->guessExtension();

            // Move the file to the directory where brochures are stored
            $PhotoDir=$this->getParameter('kernel.root_dir').'/../web/uploads';
            $file->move($PhotoDir,$fileName);

            // Update the 'brochure' property to store the PDF file name
            // instead of its contents
            $org->setImage($fileName);


            $em = $this->getDoctrine()->getManager();

            $em->persist($org);
            $em->flush();
            echo '<script type="text/javascript">' . 'alert("Ajout Avec Succes ");' . '</script>';
            return $this->redirectToRoute('_AfficherOrganismeExterne');
        }

        return $this->render('@OrganismeExterne/ModifierOrganismeExterne.html.twig',array('form'=>$Form->createView()));
    }

    public function AfficherOrganismeExterneFrontAction()
    {

        $em=$this->getDoctrine()->getManager();
        $org=$em->getRepository('AppBundle:Organismeextern')->findAll();


        return $this->render('@OrganismeExterne/AfficherOrganismeExterneFront.html.twig',
            array(
                'v'=>$org
            ));
    }


    public function AfficheDetailsAction($idOrg)
    {
        $em= $this->getDoctrine()->getManager();

        $org=$em->getRepository("AppBundle:Organismeextern")->find($idOrg);
        return $this->render('@OrganismeExterne/AfficheDetails.html.twig', array(
            "v"=>$org));
    }

    public function sort1Action($sort1)
    {
        $entityManager = $this->getDoctrine()->getManager();

        if ($sort1=='ASC'){
            $query = $entityManager->createQuery(
                'SELECT v 
    FROM AppBundle:Organismeextern v
    ORDER BY v.name ASC'
            );
        }else {
            $query = $entityManager->createQuery(
                'SELECT v
    FROM AppBundle:Organismeextern v
    ORDER BY v.name DESC'
            );
        }


        $v = $query->getResult();

        return $this->render('@OrganismeExterne/AfficherOrganismeExterne.html.twig', array(
            'v' => $v,
        ));
    }
}
